// Copyright 2025 RnD Center "ELVEES", JSC

#ifndef MAT_MUL_WITH_DMA_H
#define MAT_MUL_WITH_DMA_H
#endif

#include "elcore50-matrix-lib/common.h"

//#define DEBUG
//#define NO_CALC
//#define NO_DMA
//#define MANUAL_TILE_SIZE
//#define PERFORMANCE

void size_selector_fl16_offsets_K(int M, int K, int N, int& buf_M, int& buf_K, int& buf_N,
                                  int count_buf_A, int count_buf_B, int count_buf_C, int& offsetA, int& offsetB);

void size_selector_fl16_offsets_K_res_init(int M, int K, int N, int& buf_M, int& buf_K, int& buf_N,
                                  int count_buf_A, int count_buf_B, int count_buf_C, int& offsetA, int& offsetB);

extern "C" void mat_mul_fl16_16x128_fl16_aliquantM(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_aliquantM_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_aliquantM_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);

extern "C" void mat_mul_fl16_16x128_fl16_aliquantM_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_16x128_fl16_aliquantM_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_16x128_fl16_aliquantM_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);

extern "C" void mat_mul_fl16_16x128_fl16_general(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_general_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_general_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_16x128_fl16_general_no_ld_res_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);

extern "C" void mat_mul_fl16_32x64_fl16_aliquantM(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_aliquantM_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_aliquantM_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);

extern "C" void mat_mul_fl16_32x64_fl16_aliquantM_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_32x64_fl16_aliquantM_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_32x64_fl16_aliquantM_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);

extern "C" void mat_mul_fl16_32x64_fl16_general(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_general_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_general_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_32x64_fl16_general_no_ld_res_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);

extern "C" void mat_mul_fl16_64x32_fl16_aliquantM(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_aliquantM_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_aliquantM_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                     uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                     int* tics, int* instr);

extern "C" void mat_mul_fl16_64x32_fl16_aliquantM_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_64x32_fl16_aliquantM_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_64x32_fl16_aliquantM_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                int* tics, int* instr, float* init_vector);

extern "C" void mat_mul_fl16_64x32_fl16_general(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_general_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_general_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res_relu(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);
extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res_relu6(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr);

extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res_relu_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);
extern "C" void mat_mul_fl16_64x32_fl16_general_no_ld_res_relu6_init_vec(uint16_t* in1, int row, int col0row1, uint16_t* in2, int col1,
                                                        uint16_t* out, int offsetA, int offsetB, int real_col, int flag,
                                                        int* tics, int* instr, float* init_vector);


void init_chain_one_buf_ver_nkm_fl16(uint16_t* src0, int row0, int row1col0,
                                    uint16_t* src1, int col1, uint16_t* dst,
                                    int& offset_A, int& offset_B,
                                    LocalMemBufFl16* buffer, MatMulDmaChains4* chains);

void mat_mul_dma_one_buf_ver_nkm_fl16(uint16_t* src0, int row0, int row1col0, uint16_t* src1, int col1,
                                      uint16_t* dst, int offset_A, int offset_B,
                                      LocalMemBufFl16 *buffer, MatMulDmaChains4* chains, Store_version st_ver);

void init_chain_dma_two_buf_ver_nkm_fl16(uint16_t* src0, int row0, int row1col0,
                                         uint16_t* src1, int col1, uint16_t* dst,
                                         int& offset_A, int& offset_B,
                                         LocalMemBufFl16* buffer, MatMulDmaChains4* chains);

void mat_mul_dma_two_buf_ver_nkm_fl16(uint16_t* src0, int row0, int row1col0, uint16_t* src1, int col1,
                                      uint16_t* dst, int offset_A, int offset_B,
                                      LocalMemBufFl16 *buffer, MatMulDmaChains4* chains, Store_version st_ver);

void init_chain_dma_two_buf_ver_nkm_fl16_refactor(uint16_t* src0, int row0, int row1col0,
                                                  uint16_t* src1, int col1, uint16_t* dst,
                                                  int& offset_A, int& offset_B,
                                                  LocalMemBufFl16* buffer, MatMulDmaChains4* chains);

void mat_mul_dma_two_buf_ver_nkm_fl16_refactor(uint16_t* src0, int row0, int row1col0, uint16_t* src1, int col1,
                                               uint16_t* dst, int offset_A, int offset_B,
                                               LocalMemBufFl16 *buffer, MatMulDmaChains4* chains, Store_version st_ver);

void init_chain_dma_two_buf_ver_nkm_fl16_refactor_res_init(uint16_t* src0, int row0, int row1col0,
                                                  uint16_t* src1, int col1, uint16_t* dst,
                                                  int& offset_A, int& offset_B,
                                                  LocalMemBufFl16* buffer, MatMulDmaChains4* chains,
                                                  float* init_vector);

void mat_mul_dma_two_buf_ver_nkm_fl16_refactor_res_init(uint16_t* src0, int row0, int row1col0, uint16_t* src1, int col1,
                                               uint16_t* dst, int offset_A, int offset_B,
                                               LocalMemBufFl16 *buffer, MatMulDmaChains4* chains, Store_version st_ver,
                                               float* init_vector);
void init_chain_dma_two_buf_ver_nkm_fl16_refactor_res_init_offsets(uint16_t* src0, int row0, int row1col0,
                                                  uint16_t* src1, int col1, uint16_t* dst,
                                                  int& offset_A, int& offset_B,
                                                  LocalMemBufFl16* buffer, MatMulDmaChains4* chains, float* init_vector,
                                                  int offset_src0, int offset_dst, uint16_t* start_adr);
void mat_mul_dma_two_buf_ver_nkm_fl16_refactor_res_init_offsets(uint16_t* src0, int row0, int row1col0, uint16_t* src1, int col1,
                                               uint16_t* dst, int offset_A, int offset_B,
                                               LocalMemBufFl16 *buffer, MatMulDmaChains4* chains, Store_version st_ver,
                                               float* init_vector);
